﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Interpolace
{
    public partial class Hlavni : Form
    {
        Interpolace inter;
        /// <summary>
        /// Main GUI Window
        /// </summary>
        public Hlavni()
        {
            InitializeComponent();
            inter = new Interpolace();
        }

        private void grpInterpolace_Enter(object sender, EventArgs e)
        {

        }

        private void Hlavni_Load(object sender, EventArgs e)
        {
            picDekorace.Image = Properties.Resources.image54;
            txtNote.AppendText("Aplikace vznikla jako soubor kódů z přednášek z předmětu Programování I. ");
            txtNote.AppendText("Aplikace nebyla nikdy řádně testována. ");
            txtNote.AppendText("Aplikace by měla být distribuována včetně zdrojových kódu v souladu s licencí Apache 2. ");
            txtNote.AppendText("Aplikaci je také možno využívat z příkazové řádky zadáním parametrů. ");

        }

        private void btnGenerovat_Click(object sender, EventArgs e)
        {
            int pocet = 50;
            try
            {
                pocet = Int32.Parse(txtPocet.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Chybne zadany pocet bodu. Bude vygenerovano 50 bodu. " + ex.Message);
            }
            inter.generovatNahodne(pocet);
            inter.ulozitDoSouboru(txtSouborUlozit.Text);
        }

        private void btnInterpolovat_Click(object sender, EventArgs e)
        {
            double exponent = 2;
            int okoli = 10;
            double x = 0;
            double y = 0;
            try
            {
                x = Double.Parse(txtX.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Chybne zadane x. Bude pouzita hodnota 0. " + ex.Message);
            }
            try
            {
                y = Double.Parse(txtY.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Chybne zadane y. Bude pouzita hodnota 0. " + ex.Message);
            }
            try
            {
                exponent = Double.Parse(txtExponent.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Chybne zadany exponent. Bude pouzita hodnota 2. " + ex.Message);
            }
            try
            {
                okoli = Int32.Parse(txtOkoli.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Chybne zadany pocet bodu v okoli. Bude pouzita hodnota 10. " + ex.Message);
            }
            //Budeme cist body ze souboru
            //O jaky typ souboru se jedna budeme rozhodovat na zaklade pripony
            //Muzeme pridat i kontrolu obsahu
            if (inter.nacist(txtSouborOtevrit.Text)) {
                Vysledek v = inter.interpolovat(x, y, exponent, okoli);
                if (v.status.Equals("KO")) {
                    MessageBox.Show("Interpolovana hodnota nemohla byt urcena. Nastala neocekavana chyba.");
                } else {
                    txtVysledek.Text = v.hodnota.ToString();
                }
            } 
        }
    }
}
